#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyAlternate 'TAVertexToUpper','TAVertexToLower',
  'TAVertexToLeft','TAVertexToRight','TAVertexToZ_xy';
use MyPrintwrap ':all';


my $level = 4;

print "  % generated by tools/$FindBin::Script\n";
print "  \\newcommand{\\MyLevel}{$level}\n";

my $n_lo = 0;
my $n_hi = 2**$level - 1;

$Printwrap = 2;
foreach my $n ($n_lo .. $n_hi) {
  my ($x,$y) = TAVertexToZ_xy($n);
  my $n2 = sprintf '%0*b', $level, $n;
  printwrap(" \\node (p$n) at ($x,$y) {\$$n2\$};");
}
printwrap_newline();

my $num_edges = 0;
$Printwrap = 2;
printwrap("\\draw");
$Printwrap += 2;
foreach my $from ($n_lo .. $n_hi) {
  foreach my $to (TAVertexToLeft($from),
                  TAVertexToRight($from),
                  TAVertexToLower($from),
                  TAVertexToUpper($from)) {
    if (defined $to
        && $to <= $n_hi
        && $to > $from) {
      printwrap(" (p$from)--(p$to)");
      $num_edges++;
    }
  }
}
printwrap(";\n");
$num_edges == 2**$level - 1
  or die "oops, num_edges=$num_edges";

print "  % end generated\n";
exit 0;
