#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';


my $size = 4;
print "  % generated by tools/$FindBin::Script\n";

# dots
$Printwrap = 2;
foreach my $y (0 .. $size) {
  foreach my $x (0 .. $size) {
    printwrap(" \\node (p$x-$y) at ($x,$y) [my dot];");
  }
  printwrap_newline();
}

# arrows lines
$Printwrap = 2;
foreach my $y (0 .. $size) {
  {
    my $x = 0;
    my $arrow = (($x+$y) % 2 ? '<-' : '');
    printwrap(" \\draw [$arrow] (p$x-$y) -- ($x-\\MyEdge, $y);");
  }
  foreach my $x (0 .. $size-1) {
    my $x2 = $x + 1;
    my $arrow = (($x+$y) % 2 ? '<-' : '->');
    printwrap(" \\draw [$arrow] (p$x-$y) -- (p$x2-$y);");
  }
  {
    my $x = $size;
    my $arrow = (($x+$y) % 2 ? '<-' : '');
    printwrap(" \\draw [$arrow] (p$x-$y) -- ($x+\\MyEdge, $y);");
  }
}
foreach my $x (0 .. $size) {
  {
    my $y = 0;
    my $arrow = (($x+$y) % 2 ? '<-' : '');
    printwrap(" \\draw [$arrow] (p$x-$y) -- ($x, $y-\\MyEdge);");
  }
  foreach my $y (0 .. $size-1) {
    my $y2 = $y + 1;
    my $arrow = (($x+$y) % 2 ? '<-' : '->');
    printwrap(" \\draw [$arrow] (p$x-$y) -- (p$x-$y2);");
  }
  {
    my $y = $size;
    my $arrow = (($x+$y) % 2 ? '<-' : '');
    printwrap(" \\draw [$arrow] (p$x-$y) -- ($x, $y+\\MyEdge);");
  }
}

printwrap_newline();
$Printwrap = 2;
printwrap("\\begin{scope}[shift=(right-pos)]\n");

# dots
$Printwrap = 4;
foreach my $y (0 .. $size) {
  foreach my $x (0 .. $size) {
    printwrap(" \\node (p$x-$y) at ($x,$y) [my dot];");
  }
  printwrap_newline();
}

$Printwrap = 4;
foreach my $y (0 .. $size) {
  {
    my $x = 0;
    my $dir   = (($x+$y) % 2 ? '-135'       : '135');
    my $yp    = (($x+$y) % 2 ? "-\\MyEdgeExp" : "+\\MyEdgeExp");
    printwrap(" \\draw (p$x-$y.$dir) -- ($x-\\MyEdgeExp, $y$yp);");
  }
  foreach my $x (0 .. $size-1) {
    my $x2 = $x+1;
    my $offset = (($x+$y) % 2 ? '+.5-\MyChamfer' : '-.5+\MyChamfer');
    printwrap(" \\draw [->] (p$x-$y) -- ($x.5-\\MyChamfer,$y$offset);");
    printwrap(" \\draw ($x.5-\\MyChamfer,$y$offset) -- ($x.5+\\MyChamfer,$y$offset);");
    printwrap(" \\draw [->] (p$x2-$y) -- ($x.5+\\MyChamfer,$y$offset);");
  }
  {
    my $x = $size;
    my $dir   = (($x+$y) % 2 ? '45' : '-45');
    my $yp    = (($x+$y) % 2 ? "+\\MyEdgeExp" : "-\\MyEdgeExp");
    printwrap(" \\draw (p$x-$y.$dir) -- ($x+\\MyEdgeExp, $y$yp);");
  }
  printwrap_newline();
}

foreach my $x (0 .. $size) {
  {
    my $y = 0;
    my $dir   = (($x+$y) % 2 ? '-45' : '-135');
    my $xp    = (($x+$y) % 2 ? "+\\MyEdgeExp" : "-\\MyEdgeExp");
    printwrap(" \\draw (p$x-$y.$dir) -- ($x$xp, $y-\\MyEdgeExp);");
  }
  foreach my $y (0 .. $size-1) {
    my $y2 = $y+1;
    my $offset = (($x+$y) % 2 ? '-.5+\MyChamfer' : '+.5-\MyChamfer');
    printwrap(" \\draw [->] (p$x-$y)--($x$offset,$y.5-\\MyChamfer);");
    printwrap(" \\draw ($x$offset,$y.5-\\MyChamfer)--($x$offset,$y.5+\\MyChamfer);");
    printwrap(" \\draw [->] (p$x-$y2) -- ($x$offset,$y.5+\\MyChamfer);");
  }
  {
    my $y = $size;
    my $dir   = (($x+$y) % 2 ? '135' : '45');
    my $xp    = (($x+$y) % 2 ? "-\\MyEdgeExp" : "+\\MyEdgeExp");
    printwrap(" \\draw (p$x-$y.$dir) -- ($x$xp, $y+\\MyEdgeExp);");
  }
  printwrap_newline();
}

$Printwrap = 2;
printwrap("\\end{scope}\n");

printwrap("% end generated\n");
exit 0;
